# coding=utf-8
from zope.schema.vocabulary import SimpleVocabulary, SimpleTerm

timezone_list = (
    # REMOVED: ('01', u'(GMT-12:00) International Date Line West'),
    ('02', u'(GMT-11:00) Midway Island, Samoa'),
    ('03', u'(GMT-10:00) Hawaii'),
    ('04', u'(GMT-09:00) Alaska'),
    ('05', u'(GMT-08:00) Pacific Time (US & Canada)'),
    ('06', u'(GMT-08:00) Tijuana, Baja California'),
    ('07', u'(GMT-07:00) Arizona'),
    ('08', u'(GMT-07:00) Chihuahua, La Paz, Mazatlan'),
    ('09', u'(GMT-07:00) Mountain Time (US & Canada)'),
    ('10', u'(GMT-06:00) Central America'),
    ('11', u'(GMT-06:00) Central Time (US & Canada)'),
    ('12', u'(GMT-06:00) Guadalajara, Mexico City, Monterrey'),
    ('13', u'(GMT-06:00) Saskatchewan'),
    ('14', u'(GMT-05:00) Bogota, Lima, Quito, Rio Branco'),
    ('15', u'(GMT-05:00) Eastern Time (US & Canada)'),
    ('16', u'(GMT-05:00) Indiana (East)'),
    ('17', u'(GMT-04:30) Caracas'),
    ('18', u'(GMT-04:00) Atlantic Time (Canada)'),
    ('19', u'(GMT-04:00) Manaus'),
    ('20', u'(GMT-04:00) Santiago'),
    ('21', u'(GMT-03:30) Newfoundland'),
    ('22', u'(GMT-03:00) Brasilia'),
    ('23', u'(GMT-03:00) Buenos Aires, Georgetown'),
    ('24', u'(GMT-03:00) Greenland (Nuuk)'),
    ('25', u'(GMT-03:00) Montevideo'),
    ('26', u'(GMT-02:00) Mid-Atlantic'),
    ('27', u'(GMT-01:00) Cape Verde Is.'),
    ('28', u'(GMT-01:00) Azores'),
    ('29', u'(GMT+00:00) Casablanca, Monrovia, Reykjavik'),
    ('30', u'(GMT+00:00) Greenwich Mean Time : Dublin, Edinburgh, Lisbon, London'),  # noqa
    ('31', u'(GMT+01:00) Amsterdam, Berlin, Bern, Rome, Stockholm, Vienna'),
    ('32', u'(GMT+01:00) Belgrade, Bratislava, Budapest, Ljubljana, Prague'),
    ('33', u'(GMT+01:00) Brussels, Copenhagen, Madrid, Paris'),
    ('34', u'(GMT+01:00) Sarajevo, Skopje, Warsaw, Zagreb'),
    ('35', u'(GMT+01:00) West Central Africa'),
    ('36', u'(GMT+02:00) Amman'),
    ('37', u'(GMT+02:00) Athens, Bucharest, Istanbul'),
    ('38', u'(GMT+02:00) Beirut'),
    ('39', u'(GMT+02:00) Cairo'),
    ('40', u'(GMT+02:00) Harare, Pretoria'),
    ('41', u'(GMT+02:00) Helsinki, Kyiv, Riga, Sofia, Tallinn, Vilnius'),
    ('42', u'(GMT+02:00) Jerusalem'),
    ('43', u'(GMT+02:00) Minsk'),
    ('44', u'(GMT+02:00) Windhoek'),
    ('45', u'(GMT+03:00) Kuwait, Riyadh, Baghdad'),
    ('46', u'(GMT+03:00) Moscow, St. Petersburg, Volgograd'),
    ('47', u'(GMT+03:00) Nairobi'),
    ('48', u'(GMT+03:00) Tbilisi'),
    ('49', u'(GMT+03:30) Tehran'),
    ('50', u'(GMT+04:00) Abu Dhabi, Muscat'),
    ('51', u'(GMT+04:00) Baku'),
    ('52', u'(GMT+04:00) Yerevan'),
    ('53', u'(GMT+04:30) Kabul'),
    ('54', u'(GMT+05:00) Yekaterinburg'),
    ('55', u'(GMT+05:00) Islamabad, Karachi, Tashkent'),
    ('56', u'(GMT+05:30) Sri Jayawardenapura'),
    ('57', u'(GMT+05:30) Chennai, Kolkata, Mumbai, New Delhi'),
    ('58', u'(GMT+05:45) Kathmandu'),
    ('59', u'(GMT+06:00) Almaty, Novosibirsk'),
    ('60', u'(GMT+06:00) Astana, Dhaka'),
    ('61', u'(GMT+06:30) Yangon (Rangoon)'),
    ('62', u'(GMT+07:00) Bangkok, Hanoi, Jakarta'),
    ('63', u'(GMT+07:00) Krasnoyarsk'),
    ('64', u'(GMT+08:00) Beijing, Chongqing, Hong Kong, Urumqi'),
    ('65', u'(GMT+08:00) Kuala Lumpur, Singapore'),
    ('66', u'(GMT+08:00) Irkutsk, Ulaan Bataar'),
    ('67', u'(GMT+08:00) Perth'),
    ('68', u'(GMT+08:00) Taipei'),
    ('69', u'(GMT+09:00) Osaka, Sapporo, Tokyo'),
    ('70', u'(GMT+09:00) Seoul'),
    ('71', u'(GMT+09:00) Yakutsk'),
    ('72', u'(GMT+09:30) Adelaide'),
    ('73', u'(GMT+09:30) Darwin'),
    ('74', u'(GMT+10:00) Brisbane'),
    ('75', u'(GMT+10:00) Canberra, Melbourne, Sydney'),
    ('76', u'(GMT+10:00) Hobart'),
    ('77', u'(GMT+10:00) Guam, Port Moresby'),
    ('78', u'(GMT+10:00) Vladivostok'),
    ('79', u'(GMT+11:00) Magadan, Solomon Is., New Caledonia'),
    ('80', u'(GMT+12:00) Auckland, Wellington'),
    ('81', u'(GMT+12:00) Fiji, Kamchatka, Marshall Is.'),
    ('82', u'(GMT+13:00) Nuku\'alofa'),
)


terms = [SimpleTerm(value=p[0], token=p[0], title=p[1]) for p in timezone_list]
timezone_vocabulary = SimpleVocabulary(terms)
